#!/usr/bin/perl -I/usr/sausalito/perl
#
# $Id: ave_traffic.cgi, v 1.0.0.2 Thu 03 Apr 2008 04:30:00 PM CEST mstauber Exp $
# Copyright 2006-2008 Solarspeed Ltd. All rights reserved.
#
# This handler polls the RRD databases for the master node and VPS network traffic
# statistics and then generates the respective traffic graphics.
#

use CCE;
use POSIX qw(isalpha);
use RRDs;
use Sys::Hostname;
use File::Spec;

$host = hostname();

$DEBUG = 0;

$cce = new CCE('Domain' => 'vz-traffic');

$cce->connectfd();

$img = '/usr/sausalito/ui/web/vz/traffic/images';
$rrd = '/var/lib/averrd';

opendir (DIR,"$rrd");
while ($datei = readdir(DIR)) {
	if ($datei =~ /\.rrd/) {
		@mgraphs=split(/\./,$datei);
		push (@graphs, $mgraphs[0]);
	}
}
closedir(DIR);

@sorted_graphs = sort { lc($a) cmp lc($b) } (@graphs);
foreach $line (@sorted_graphs) {

	$hostname = "";
	@vpsid = split(/_/,$line);
        ($sys_oid) = $cce->find('Vserver', { 'vpsid' => $vpsid[1]  });
        ($ok, $sys) = $cce->get($sys_oid);
	$hostname = $sys->{'hostname'};

	if ($hostname ne "") {
        	&CreateGraph($line, "day", $hostname);
        	&CreateGraph($line, "week", $hostname);
        	&CreateGraph($line, "month", $hostname);
        	&CreateGraph($line, "year", $hostname);
	}
	else {
	        &CreateGraph($line, "day", $host);
        	&CreateGraph($line, "week", $host);
        	&CreateGraph($line, "month", $host);
        	&CreateGraph($line, "year", $host);
	}
}


sub CreateGraph
{
# creates graph
# inputs: $_[0]: interface name (ie, eth0/eth1/eth2/ppp0)
#         $_[1]: interval (ie, day, week, month, year)
#         $_[2]: interface description

        RRDs::graph "$img/$_[0]-$_[1].png",
                "-s -1$_[1]",
                "-t traffic on $_[0] :: $_[2]",
                "--lazy",
                "-h", "80", "-w", "600",
                "-l 0",
                "-a", "PNG",
                "-v bytes/sec",
                "DEF:in=$rrd/$_[0].rrd:in:AVERAGE",
                "DEF:out=$rrd/$_[0].rrd:out:AVERAGE",
                "CDEF:out_neg=out,-1,*",
                "AREA:in#32CD32:Incoming",
                "LINE1:in#336600",
                "GPRINT:in:MAX:  Max\\: %5.1lf %s",
                "GPRINT:in:AVERAGE: Avg\\: %5.1lf %S",
                "GPRINT:in:LAST: Current\\: %5.1lf %Sbytes/sec\\n",
                "AREA:out_neg#4169E1:Outgoing",
                "LINE1:out_neg#0033CC",
                "GPRINT:out:MAX:  Max\\: %5.1lf %S",
                "GPRINT:out:AVERAGE: Avg\\: %5.1lf %S",
                "GPRINT:out:LAST: Current\\: %5.1lf %Sbytes/sec",
                "HRULE:0#000000";
        #if ($ERROR = RRDs::error) { print "$0: unable to generate $_[0] $_[1] traffic graph: $ERROR\n"; }

        # Fix permissions:
        system("/bin/chmod 644 $img/$_[0]-$_[1].png");
}

$cce->bye('SUCCESS');
exit(0);

